var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp2, _class$defaultProps;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import PropTypes from 'prop-types';
import React, { Component } from 'react';
import _ from 'lodash';
import moment from 'moment';
import GanttTimeline from './GanttTimeline';

import _GanttRow from './GanttRow';
export { _GanttRow as GanttRow };
var ReactGantt = (_temp2 = _class = function (_Component) {
  _inherits(ReactGantt, _Component);

  function ReactGantt() {
    var _temp, _this, _ret;

    _classCallCheck(this, ReactGantt);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
      timelineWidth: 0
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  ReactGantt.prototype.componentDidMount = function componentDidMount() {
    var _this2 = this;

    this.resizeEventListener = window.addEventListener('resize', function (e) {
      return _this2.handleResize(e);
    });
    this.handleResize();
  };

  ReactGantt.prototype.componentWillUnmount = function componentWillUnmount() {
    this.resizeEventListener.removeEventListener();
  };

  ReactGantt.prototype.getChildContext = function getChildContext() {
    return {
      templates: this.props.templates,
      dateFormat: this.props.dateFormat,
      timeFormat: this.props.timeFormat,
      secondFormat: this.props.secondFormat,
      hourFormat: this.props.hourFormat,
      dayFormat: this.props.dayFormat,
      weekFormat: this.props.weekFormat,
      monthFormat: this.props.monthFormat,
      yearFormat: this.props.yearFormat,
      debug: this.props.debug,
      leftBound: this.props.leftBound,
      rightBound: this.props.rightBound,
      timelineWidth: this.state.timelineWidth
    };
  };

  ReactGantt.prototype.render = function render() {
    var thStyle = { whiteSpace: 'nowrap' };
    return React.createElement(
      'div',
      { style: this.props.style },
      React.createElement(
        'table',
        { style: { width: '100%' }, cellSpacing: 0 },
        React.createElement(
          'thead',
          null,
          React.createElement(
            'tr',
            null,
            React.createElement('th', { style: _extends({}, thStyle, {
                width: '0px'
              }) }),
            React.createElement(
              'th',
              { ref: 'timeline', style: _extends({}, thStyle, {
                  width: '100%'
                }) },
              React.createElement(GanttTimeline, { style: this.props.timelineStyle, rows: this.props.children })
            )
          )
        ),
        React.createElement(
          'tbody',
          null,
          this.props.children
        )
      )
    );
  };

  ReactGantt.prototype.handleResize = function handleResize(e) {
    this.setState({ timelineWidth: 0 });
    this.setState({ timelineWidth: this.refs.timeline.offsetWidth });
  };

  return ReactGantt;
}(Component), _class.childContextTypes = {
  templates: PropTypes.object.isRequired,
  dateFormat: PropTypes.string.isRequired,
  timeFormat: PropTypes.string,
  secondFormat: PropTypes.string,
  hourFormat: PropTypes.string,
  dayFormat: PropTypes.string,
  weekFormat: PropTypes.string,
  monthFormat: PropTypes.string,
  yearFormat: PropTypes.string,
  debug: PropTypes.bool.isRequired,
  leftBound: PropTypes.object.isRequired,
  rightBound: PropTypes.object.isRequired,
  timelineWidth: PropTypes.number.isRequired
}, _class.defaultProps = (_class$defaultProps = {
  dateFormat: 'YY-MM-DD',
  timeFormat: 'YY-MM-DD HH:MM',
  secondFormat: 'HH:MM:SS',
  minuteFormat: 'HH:MM',
  hourFormat: 'HH',
  dayFormat: 'YY-MM-DD',
  weekFormat: 'YY-MM-DD',
  monthFormat: 'YY-MM-DD',
  yearFormat: 'YY-MM-DD',
  debug: false,
  leftBound: moment().toDate()
}, _class$defaultProps['leftBound'] = moment().toDate(), _class$defaultProps.style = {}, _class$defaultProps.templates = {}, _class$defaultProps.timelineStyle = {
  minWidth: '60px'
}, _class$defaultProps), _temp2);
export { ReactGantt as default };
ReactGantt.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node.isRequired,
  dateFormat: PropTypes.string,
  timeFormat: PropTypes.string,
  secondFormat: PropTypes.string,
  hourFormat: PropTypes.string,
  dayFormat: PropTypes.string,
  weekFormat: PropTypes.string,
  monthFormat: PropTypes.string,
  yearFormat: PropTypes.string,
  debug: PropTypes.bool,
  leftBound: PropTypes.object,
  rightBound: PropTypes.object,
  style: PropTypes.object,
  templates: PropTypes.object,
  timelineStyle: PropTypes.object
} : {};