'use strict';

exports.__esModule = true;
exports.default = exports.GanttRow = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp2, _class$defaultProps;

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _GanttTimeline = require('./GanttTimeline');

var _GanttTimeline2 = _interopRequireDefault(_GanttTimeline);

var _GanttRow2 = require('./GanttRow');

var _GanttRow3 = _interopRequireDefault(_GanttRow2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

exports.GanttRow = _GanttRow3.default;
var ReactGantt = (_temp2 = _class = function (_Component) {
  _inherits(ReactGantt, _Component);

  function ReactGantt() {
    var _temp, _this, _ret;

    _classCallCheck(this, ReactGantt);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
      timelineWidth: 0
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  ReactGantt.prototype.componentDidMount = function componentDidMount() {
    var _this2 = this;

    this.resizeEventListener = window.addEventListener('resize', function (e) {
      return _this2.handleResize(e);
    });
    this.handleResize();
  };

  ReactGantt.prototype.componentWillUnmount = function componentWillUnmount() {
    this.resizeEventListener.removeEventListener();
  };

  ReactGantt.prototype.getChildContext = function getChildContext() {
    return {
      templates: this.props.templates,
      dateFormat: this.props.dateFormat,
      timeFormat: this.props.timeFormat,
      secondFormat: this.props.secondFormat,
      hourFormat: this.props.hourFormat,
      dayFormat: this.props.dayFormat,
      weekFormat: this.props.weekFormat,
      monthFormat: this.props.monthFormat,
      yearFormat: this.props.yearFormat,
      debug: this.props.debug,
      leftBound: this.props.leftBound,
      rightBound: this.props.rightBound,
      timelineWidth: this.state.timelineWidth
    };
  };

  ReactGantt.prototype.render = function render() {
    var thStyle = { whiteSpace: 'nowrap' };
    return _react2.default.createElement(
      'div',
      { style: this.props.style },
      _react2.default.createElement(
        'table',
        { style: { width: '100%' }, cellSpacing: 0 },
        _react2.default.createElement(
          'thead',
          null,
          _react2.default.createElement(
            'tr',
            null,
            _react2.default.createElement('th', { style: _extends({}, thStyle, {
                width: '0px'
              }) }),
            _react2.default.createElement(
              'th',
              { ref: 'timeline', style: _extends({}, thStyle, {
                  width: '100%'
                }) },
              _react2.default.createElement(_GanttTimeline2.default, { style: this.props.timelineStyle, rows: this.props.children })
            )
          )
        ),
        _react2.default.createElement(
          'tbody',
          null,
          this.props.children
        )
      )
    );
  };

  ReactGantt.prototype.handleResize = function handleResize(e) {
    this.setState({ timelineWidth: 0 });
    this.setState({ timelineWidth: this.refs.timeline.offsetWidth });
  };

  return ReactGantt;
}(_react.Component), _class.childContextTypes = {
  templates: _propTypes2.default.object.isRequired,
  dateFormat: _propTypes2.default.string.isRequired,
  timeFormat: _propTypes2.default.string,
  secondFormat: _propTypes2.default.string,
  hourFormat: _propTypes2.default.string,
  dayFormat: _propTypes2.default.string,
  weekFormat: _propTypes2.default.string,
  monthFormat: _propTypes2.default.string,
  yearFormat: _propTypes2.default.string,
  debug: _propTypes2.default.bool.isRequired,
  leftBound: _propTypes2.default.object.isRequired,
  rightBound: _propTypes2.default.object.isRequired,
  timelineWidth: _propTypes2.default.number.isRequired
}, _class.defaultProps = (_class$defaultProps = {
  dateFormat: 'YY-MM-DD',
  timeFormat: 'YY-MM-DD HH:MM',
  secondFormat: 'HH:MM:SS',
  minuteFormat: 'HH:MM',
  hourFormat: 'HH',
  dayFormat: 'YY-MM-DD',
  weekFormat: 'YY-MM-DD',
  monthFormat: 'YY-MM-DD',
  yearFormat: 'YY-MM-DD',
  debug: false,
  leftBound: (0, _moment2.default)().toDate()
}, _class$defaultProps['leftBound'] = (0, _moment2.default)().toDate(), _class$defaultProps.style = {}, _class$defaultProps.templates = {}, _class$defaultProps.timelineStyle = {
  minWidth: '60px'
}, _class$defaultProps), _temp2);
exports.default = ReactGantt;
ReactGantt.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes2.default.node.isRequired,
  dateFormat: _propTypes2.default.string,
  timeFormat: _propTypes2.default.string,
  secondFormat: _propTypes2.default.string,
  hourFormat: _propTypes2.default.string,
  dayFormat: _propTypes2.default.string,
  weekFormat: _propTypes2.default.string,
  monthFormat: _propTypes2.default.string,
  yearFormat: _propTypes2.default.string,
  debug: _propTypes2.default.bool,
  leftBound: _propTypes2.default.object,
  rightBound: _propTypes2.default.object,
  style: _propTypes2.default.object,
  templates: _propTypes2.default.object,
  timelineStyle: _propTypes2.default.object
} : {};